#!/bin/sh
distro=$1
launcher=$2
pkgtype=$3

if [ -z "$distro" -o "$distro" != "deb" -a "$distro" != "rhel" ] 
then
    echo "Usage: install.sh <distro> <launcher> <pkg_type>"
    echo "Please set target distro and re-run"
    echo "Valid options: deb, rhel"
    exit -1
fi

if [ -z "$launcher" -o "$launcher" != "mpirun" -a "$launcher" != "slurm" -a "$launcher" != "pbs" ] 
then
    echo "Usage: install.sh <distro> <launcher> <pkg_type>"
    echo "Please set target launcher and re-run"
    echo "Valid options: mpirun, slurm, pbs"
    exit -1
fi

if [ -z "$pkgtype" -o "$pkgtype" != "basic" -a "$pkgtype" != "basic-xpmem" ] 
then
    echo "Usage: install.sh <distro> <pkgtype> <pkg_type>"
    echo "Please set target pkgtype and re-run"
    echo "Valid options: basic, basic-xpmem"
    exit -1
fi

if [ "$distro" == "rhel" ] 
then
    if [ "$launcher" == "slurm" ] 
    then
        rpm -Uvh --nodeps mvapich2-x-$pkgtype-stock-gnu4.8.5-slurm-2.3rc2-1.el7.x86_64.rpm
    elif [ "$launcher" == "pbs" ] 
    then
        rpm -Uvh --nodeps mvapich2-x-$pkgtype-stock-gnu4.8.5-pbs-2.3rc2-1.el7.x86_64.rpm
    else
        rpm -Uvh --nodeps mvapich2-x-$pkgtype-stock-gnu4.8.5-2.3rc2-1.el7.x86_64.rpm
    fi
    rpm -Uvh --nodeps berkeley_upc-osu_gnu4.8.5-2.3rc2-1.el7.x86_64.rpm
    rpm -Uvh --nodeps berkeley_upcxx-osu_gnu4.8.5-2.3rc2-1.el7.x86_64.rpm
    rpm -Uvh --nodeps openshmem-osu_gnu4.8.5-2.3rc2-1.el7.x86_64.rpm
    rpm -Uvh --nodeps osu-micro-benchmarks_gnu4.8.5-5.6.1-1.el7.x86_64.rpm
else
    if [ "$launcher" == "slurm" ] 
    then
        dpkg  --force-all -i ./mvapich2-x-$pkgtype-stock-gnu4.8.5-slurm_2.3rc2-1.el7_amd64.deb
    elif [ "$launcher" == "pbs" ] 
    then
        dpkg  --force-all -i ./mvapich2-x-$pkgtype-stock-gnu4.8.5-pbs_2.3rc2-1.el7_amd64.deb
    else
        dpkg  --force-all -i ./mvapich2-x-$pkgtype-stock-gnu2.3rc2-1.el7_amd64.deb
    fi
    dpkg  --force-all -i ./berkeley_upc-osu_gnu2.3rc2-1.el7_amd64.deb
    dpkg  --force-all -i ./berkeley_upcxx-osu_gnu2.3rc2-1.el7_amd64.deb
    dpkg  --force-all -i ./openshmem-osu_gnu2.3rc2-1.el7_amd64.deb
    dpkg  --force-all -i ./osu-micro-benchmarks_gnu4.8.5-5.6.1-1.el7.x86_64.rpm
fi
